package com.yanzuoguang.util.exception;

/**
 * 途比达异常信息
 *
 * @author 颜佐光
 */
public class CodeException extends RuntimeException {


    private static final long serialVersionUID = -4625832188480820883L;
    /**
     * 错误码
     */
    private String code = "99";

    /**
     * 包含的数据
     */
    private Object target = null;

    /**
     * 获取错误码
     *
     * @return 返回的结果
     */
    public String getCode() {
        return this.code;
    }

    /**
     * 来源数据
     *
     * @return
     */
    public Object getTarget() {
        return target;
    }

    /**
     * Constructs a new runtime exception with the specified detail message and
     * cause.  <p>Note that the detail message associated with
     * {@code cause} is <i>not</i> automatically incorporated in
     * this runtime exception's detail message.
     *
     * @param code    the detail code (which is saved for later retrieval
     *                by the {@link #getCode()} method).
     * @param message the detail message (which is saved for later retrieval
     *                by the {@link #getMessage()} method).
     * @param cause   the cause (which is saved for later retrieval by the
     *                {@link #getCause()} method).  (A <tt>null</tt> value is
     *                permitted, and indicates that the cause is nonexistent or
     *                unknown.)
     * @since 1.4
     */
    public CodeException(String code, String message, Throwable cause) {
        super(message, cause);
        this.code = code;
    }

    /**
     * 构造函数
     * throw new CodeException("01","该订单已过期",order);
     * throw new CodeException("02","该订单未到使用时间",order);
     *
     * @param code    　错误码
     * @param message 　错误消息
     * @param target  　错误数据源，如订单数据
     */
    public CodeException(String code, String message, Object target) {
        super(message);
        this.code = code;
        this.target = target;
    }

    /**
     * Constructs a new runtime exception with the specified detail message and
     * cause.  <p>Note that the detail message associated with
     * {@code cause} is <i>not</i> automatically incorporated in
     * this runtime exception's detail message.
     *
     * @param message the detail message (which is saved for later retrieval
     *                by the {@link #getMessage()} method).
     * @param cause   the cause (which is saved for later retrieval by the
     *                {@link #getCause()} method).  (A <tt>null</tt> value is
     *                permitted, and indicates that the cause is nonexistent or
     *                unknown.)
     * @since 1.4
     */
    public CodeException(String message, Throwable cause) {
        super(message, cause);
    }


    /**
     * Constructs a new runtime exception with {@code null} as its
     * detail message.  The cause is not initialized, and may subsequently be
     * initialized by a call to {@link #initCause}.
     */
    public CodeException() {
        super();
    }

    /**
     * Constructs a new runtime exception with the specified detail message.
     * The cause is not initialized, and may subsequently be initialized by a
     * call to {@link #initCause}.
     *
     * @param code    the detail code (which is saved for later retrieval
     *                by the {@link #getCode()} method).
     * @param message the detail message. The detail message is saved for
     *                later retrieval by the {@link #getMessage()} method.
     */
    public CodeException(String code, String message) {
        super(message);
        this.code = code;
    }

    /**
     * Constructs a new runtime exception with the specified detail message.
     * The cause is not initialized, and may subsequently be initialized by a
     * call to {@link #initCause}.
     *
     * @param message the detail message. The detail message is saved for
     *                later retrieval by the {@link #getMessage()} method.
     */
    public CodeException(String message) {
        super(message);
    }


    /**
     * Constructs a new runtime exception with the specified detail message and
     * cause.  <p>Note that the detail message associated with
     * {@code cause} is <i>not</i> automatically incorporated in
     * this runtime exception's detail message.
     *
     * @param cause the cause (which is saved for later retrieval by the
     *              {@link #getCause()} method).  (A <tt>null</tt> value is
     *              permitted, and indicates that the cause is nonexistent or
     *              unknown.)
     * @since 1.4
     */
    public CodeException(Throwable cause) {
        super(cause);
    }
}
